#include <math.h>
#include <stdio.h>
#include "iir.h"


void iir_5_8_plain (float *source, float *dest, int size)
{
  int i;
  float a0 = 0.65, a1 = 0.6, a2 = 0.55, a3 = 0.5,  a4 = 0.45;
  float b1 = 0.02, b2 = 0.15, b3 = 0.1, b4 = 0.05, b5 = 0.02, b6 = 0.15, b7 = 0.1, b8 = 0.05;
  float *sp = source, *dp = dest;
  float y9, y8, y7, y6, y5, y4, y3, y2, y1;
  y9 = y8 = y7 = y6 = y5 = y4 = y3 = y2 = y1 = 0.0;
  for (i = size; i > 0; i --)
  {
    y9 = sp[0] * a0 + sp[-1] * a1 + sp[-2] * a2 + sp[-3] * a3 + sp[-4] * a4 + 
   	 y8 * b1 + y7 * b2 + y6 * b3 + y5 * b4 + y4 * b5 + y3 * b6 + y2 * b7 + y1 * b8;
    *dp = y9;
    y1 = y2;  y2 = y3; y3 = y4; y4 = y5;  y5 = y6;  y6 = y7; y7 = y8; y8 = y9;
    sp ++;  dp ++;
  }
}

void iir_5_8_vec (float *source, float *dest, int size)
{
}
