#include "iir.h"
#include "math.h"
//#include <stdio.h>

void iir_7_6_plain (float *source, float *dest, int size)
{
  float a0 = 0.06, a1 = 0.05, a2 = 0.04, a3 = 0.03, a4 = 0.02, a5 = 0.01, a6 = 0.005;
  float b1 = 0.05, b2 = 0.04, b3 = 0.03, b4 = 0.02, b5 = 0.01, b6 = 0.005;
  int i;
  float *sp = source, *dp = dest;
  float y = 0.0;
  for (i = size; i > 0; i --)
  {
	y = *sp*a0 + *(sp-1)*a1 + *(sp-2)*a2 + *(sp-3)*a3 + *(sp-4)*a4 + *(sp-5)*a5 + *(sp-6)*a6
		   + *(dp-1)*b1 + *(dp-2)*b2 + *(dp-3)*b3 + *(dp-4)*b4 + *(dp-5)*b5 + *(dp-6)*b6;
    
    *dp = y;
    sp ++; 
    dp ++;
     /*
    y = *sp * a + y * b;
    *dp = y;
    sp ++;  dp ++;
   */	
  }
}

void iir_7_6_vec (float *source, float *dest, int size)
{
  typedef int v4sf __attribute__ ((mode(V4SF)));

  int i;
  float a0 = 0.6, a1 = 0.5, a2 = 0.4, a3 = 0.3, a4 = 0.2, a5 = 0.1, a6 = 0.05;
  float b0 = 0.5, b1 = 0.4, b2 = 0.3, b3 = 0.2, b4 = 0.1, b5 = 0.05;

/*  float __attribute__ ((aligned (16))) aaaa_arr[] = {a, a, a, a};
  v4sf aaaa = * (v4sf *) &aaaa_arr;
  float __attribute__ ((aligned (16))) b____arr[] = {b, 0, 0, 0};
  v4sf b___ = * (v4sf *) &b____arr;
  float __attribute__ ((aligned (16))) _b_b_arr[] = {0, b, 0, b};
  v4sf _b_b = * (v4sf *) &_b_b_arr;
  float __attribute__ ((aligned (16))) __bB_arr[] = {0, 0, b, b*b};
  v4sf __bB = * (v4sf *) &__bB_arr;
  float __attribute__ ((aligned (16))) zero_arr[] = {0, 0, 0, 0};
  v4sf zero = * (v4sf *) &zero_arr;
  float *sp = source, *dp = dest;
  v4sf s = zero, s2;

  for (i = size/4; i > 0; i --)
  {
    s =   __builtin_ia32_loadaps (sp) * aaaa
        + __builtin_ia32_shufps (s, s, select (3, 0, 0, 0)) * b___;
    s += __builtin_ia32_shufps (s, s, select (0, 0, 0, 2)) * _b_b;
    s += __builtin_ia32_shufps (s, s, select (0, 0, 1, 1)) * __bB;

    __builtin_ia32_storeaps (dp, s);
    sp += 4;  dp += 4;
  }*/

}
