#include <math.h>
#include <stdio.h>
#include "iir.h"


void iir_9_4_plain (float *source, float *dest, int size)
{
  int i;
  float a0 = 0.65, a1 = 0.6, a2 = 0.55, a3 = 0.5, 
  		a4 = 0.45, a5 = 0.4, a6 = 0.35, a7 = 0.3, 
  		a8 = 0.25; 
  float b1 = 0.2, b2 = 0.15, b3 = 0.1, b4 = 0.05;
  float *sp = source, *dp = dest;
  float y5 = 0.0, y4 = 0.0, y3 = 0.0, y2 = 0.0, y1 = 0.0;
  for (i = size; i > 0; i --)
  {
    y5 = sp[0] * a0 + sp[-1] * a1 + sp[-2] * a2 + sp[-3] * a3 + sp[-4] * a4 + 
    	 sp[-5] * a5 + sp[-6] * a6 + sp[-7] * a7 + sp[-8] * a8 + 
    	 y5 * b1 + y4 * b2 + y3 * b3 + y2 * b4;
    *dp = y5;
    y1 = y2;  y2 = y3; y3 = y4; y4 = y5;
    sp ++;  dp ++;
  }
}

void iir_9_4_vec (float *source, float *dest, int size)
{
}
